Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeGrammarView.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeGrammarView.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeGrammarView.cs	(revision 5686)
@@ -70,5 +70,5 @@
         ClearSymbols();
         foreach (Symbol symbol in Content.Symbols) {
-          if (!(symbol is ReadOnlySymbol)) {
+          if (!(symbol is IReadOnlySymbol)) {
             symbol.Changed += new EventHandler(symbol_Changed);
             symbols.Add(symbol, symbol.InitialFrequency > 0.0);
Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ProbabilisticTreeCreaterTest.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ProbabilisticTreeCreaterTest.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ProbabilisticTreeCreaterTest.cs	(revision 5686)
@@ -22,4 +22,5 @@
 using System;
 using System.Collections.Generic;
+using System.Diagnostics;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Creators;
@@ -30,5 +31,5 @@
   [TestClass]
   public class ProbabilisticTreeCreaterTest {
-    private const int POPULATION_SIZE = 1000;
+    private const int POPULATION_SIZE = 10000;
     private const int MAX_TREE_SIZE = 100;
     private const int MAX_TREE_HEIGHT = 10;
@@ -53,12 +54,18 @@
       var grammar = Grammars.CreateSimpleArithmeticGrammar();
       var random = new MersenneTwister(31415);
+      var stopwatch = new Stopwatch();
+      stopwatch.Start();
       for (int i = 0; i < POPULATION_SIZE; i++) {
         randomTrees.Add(ProbabilisticTreeCreator.Create(random, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 0, 0));
       }
+      stopwatch.Stop();
 
       foreach (var tree in randomTrees) {
         Util.IsValid(tree);
       }
+      double msPerRandomTreeCreation = stopwatch.ElapsedMilliseconds / (double)POPULATION_SIZE;
+
       Console.WriteLine("ProbabilisticTreeCreator: " + Environment.NewLine +
+        msPerRandomTreeCreation + " ms per random tree (~" + Math.Round(1000.0 / (msPerRandomTreeCreation)) + "random trees / s)" + Environment.NewLine +
         Util.GetSizeDistributionString(randomTrees, 105, 5) + Environment.NewLine +
         Util.GetFunctionDistributionString(randomTrees) + Environment.NewLine +
@@ -66,4 +73,5 @@
         Util.GetTerminalDistributionString(randomTrees) + Environment.NewLine
         );
+      Assert.IsTrue(Math.Round(1000.0 / (msPerRandomTreeCreation)) > 2000); // must achieve more than 2000 random trees / s
     }
 
@@ -74,10 +82,17 @@
       var grammar = Grammars.CreateArithmeticAndAdfGrammar();
       var random = new MersenneTwister(31415);
+      var stopwatch = new Stopwatch();
+      stopwatch.Start();
       for (int i = 0; i < POPULATION_SIZE; i++) {
-        var tree = ProbabilisticTreeCreator.Create(random, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3);
+        randomTrees.Add(ProbabilisticTreeCreator.Create(random, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3));
+      }
+      stopwatch.Stop();
+      foreach (var tree in randomTrees)
         Util.IsValid(tree);
-        randomTrees.Add(tree);
-      }
+
+      double msPerRandomTreeCreation = stopwatch.ElapsedMilliseconds / (double)POPULATION_SIZE;
+
       Console.WriteLine("ProbabilisticTreeCreator: " + Environment.NewLine +
+        msPerRandomTreeCreation + " ms per random tree (~" + Math.Round(1000.0 / (msPerRandomTreeCreation)) + "random trees / s)" + Environment.NewLine +
         Util.GetSizeDistributionString(randomTrees, 105, 5) + Environment.NewLine +
         Util.GetFunctionDistributionString(randomTrees) + Environment.NewLine +
@@ -85,4 +100,6 @@
         Util.GetTerminalDistributionString(randomTrees) + Environment.NewLine
         );
+
+      Assert.IsTrue(Math.Round(1000.0 / (msPerRandomTreeCreation)) > 2000); // must achieve more than 2000 random trees / s
     }
   }
Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentCreater.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentCreater.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentCreater.cs	(revision 5686)
@@ -26,6 +26,6 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Parameters;
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
@@ -126,5 +126,5 @@
                        where node.SubTrees.Count() > 0
                        from subtree in node.SubTrees
-                       select new { Parent = node, ReplacedChildIndex = node.IndexOfSubTree(subtree), ReplacedChild = subtree }).ToList();
+                       select new CutPoint(node, subtree)).ToList();
 
       if (cutPoints.Count() == 0)
@@ -133,7 +133,7 @@
       var selectedCutPoint = cutPoints[random.Next(cutPoints.Count)];
       // replace the branch at the cut point with an argument node
-      var replacedBranch = selectedCutPoint.ReplacedChild;
-      selectedCutPoint.Parent.RemoveSubTree(selectedCutPoint.ReplacedChildIndex);
-      selectedCutPoint.Parent.InsertSubTree(selectedCutPoint.ReplacedChildIndex, newArgumentNode);
+      var replacedBranch = selectedCutPoint.Child;
+      selectedCutPoint.Parent.RemoveSubTree(selectedCutPoint.ChildIndex);
+      selectedCutPoint.Parent.InsertSubTree(selectedCutPoint.ChildIndex, newArgumentNode);
 
       // find all old invocations of the selected ADF and attach a cloned version of the replaced branch (with all argument-nodes expanded)
@@ -167,10 +167,9 @@
       defunBranch.NumberOfArguments++;
       defunBranch.Grammar.AddSymbol(newArgumentNode.Symbol);
-      defunBranch.Grammar.SetMinSubtreeCount(newArgumentNode.Symbol, 0);
-      defunBranch.Grammar.SetMaxSubtreeCount(newArgumentNode.Symbol, 0);
+      defunBranch.Grammar.SetSubtreeCount(newArgumentNode.Symbol, 0, 0);
       // allow the argument as child of any other symbol
       foreach (var symb in defunBranch.Grammar.Symbols)
-        for (int i = 0; i < defunBranch.Grammar.GetMaxSubtreeCount(symb); i++) {
-          defunBranch.Grammar.SetAllowedChild(symb, newArgumentNode.Symbol, i);
+        for (int i = 0; i < defunBranch.Grammar.GetMaximumSubtreeCount(symb); i++) {
+          defunBranch.Grammar.AddAllowedChildSymbol(symb, newArgumentNode.Symbol, i);
         }
       foreach (var subtree in tree.Root.SubTrees) {
@@ -178,9 +177,8 @@
         var matchingSymbol = subtree.Grammar.Symbols.OfType<InvokeFunction>().Where(s => s.FunctionName == defunBranch.FunctionName).SingleOrDefault();
         if (matchingSymbol != null) {
-          subtree.Grammar.SetMinSubtreeCount(matchingSymbol, defunBranch.NumberOfArguments);
-          subtree.Grammar.SetMaxSubtreeCount(matchingSymbol, defunBranch.NumberOfArguments);
-          foreach (var child in subtree.Grammar.GetAllowedSymbols(subtree.Symbol, 0)) {
-            for (int i = 0; i < subtree.Grammar.GetMaxSubtreeCount(matchingSymbol); i++) {
-              subtree.Grammar.SetAllowedChild(matchingSymbol, child, i);
+          subtree.Grammar.SetSubtreeCount(matchingSymbol, defunBranch.NumberOfArguments, defunBranch.NumberOfArguments);
+          foreach (var child in subtree.Grammar.GetAllowedChildSymbols(subtree.Symbol, 0)) {
+            for (int i = 0; i < subtree.Grammar.GetMaximumSubtreeCount(matchingSymbol); i++) {
+              subtree.Grammar.AddAllowedChildSymbol(matchingSymbol, child, i);
             }
           }
Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDeleter.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDeleter.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDeleter.cs	(revision 5686)
@@ -84,6 +84,5 @@
         var matchingInvokeSymbol = subtree.Grammar.Symbols.OfType<InvokeFunction>().Where(s => s.FunctionName == selectedDefunBranch.FunctionName).SingleOrDefault();
         if (matchingInvokeSymbol != null) {
-          subtree.Grammar.SetMinSubtreeCount(matchingInvokeSymbol, selectedDefunBranch.NumberOfArguments);
-          subtree.Grammar.SetMaxSubtreeCount(matchingInvokeSymbol, selectedDefunBranch.NumberOfArguments);
+          subtree.Grammar.SetSubtreeCount(matchingInvokeSymbol, selectedDefunBranch.NumberOfArguments, selectedDefunBranch.NumberOfArguments);
         }
       }
Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDuplicater.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDuplicater.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDuplicater.cs	(revision 5686)
@@ -107,10 +107,9 @@
       // register the new argument symbol and increase the number of arguments of the ADF
       selectedDefunBranch.Grammar.AddSymbol(newArgSymbol);
-      selectedDefunBranch.Grammar.SetMinSubtreeCount(newArgSymbol, 0);
-      selectedDefunBranch.Grammar.SetMaxSubtreeCount(newArgSymbol, 0);
+      selectedDefunBranch.Grammar.SetSubtreeCount(newArgSymbol, 0, 0);
       // allow the argument as child of any other symbol
       foreach (var symb in selectedDefunBranch.Grammar.Symbols)
-        for (int i = 0; i < selectedDefunBranch.Grammar.GetMaxSubtreeCount(symb); i++) {
-          selectedDefunBranch.Grammar.SetAllowedChild(symb, newArgSymbol, i);
+        for (int i = 0; i < selectedDefunBranch.Grammar.GetMaximumSubtreeCount(symb); i++) {
+          selectedDefunBranch.Grammar.AddAllowedChildSymbol(symb, newArgSymbol, i);
         }
       selectedDefunBranch.NumberOfArguments++;
@@ -122,9 +121,8 @@
                                     select symb).SingleOrDefault();
         if (matchingInvokeSymbol != null) {
-          subtree.Grammar.SetMinSubtreeCount(matchingInvokeSymbol, selectedDefunBranch.NumberOfArguments);
-          subtree.Grammar.SetMaxSubtreeCount(matchingInvokeSymbol, selectedDefunBranch.NumberOfArguments);
-          foreach (var child in subtree.Grammar.GetAllowedSymbols(subtree.Symbol, 0)) {
-            for (int i = 0; i < subtree.Grammar.GetMaxSubtreeCount(matchingInvokeSymbol); i++) {
-              subtree.Grammar.SetAllowedChild(matchingInvokeSymbol, child, i);
+          subtree.Grammar.SetSubtreeCount(matchingInvokeSymbol, selectedDefunBranch.NumberOfArguments, selectedDefunBranch.NumberOfArguments);
+          foreach (var child in subtree.Grammar.GetAllowedChildSymbols(subtree.Symbol, 0)) {
+            for (int i = 0; i < subtree.Grammar.GetMaximumSubtreeCount(matchingInvokeSymbol); i++) {
+              subtree.Grammar.AddAllowedChildSymbol(matchingInvokeSymbol, child, i);
             }
           }
Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/GrammarModifier.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/GrammarModifier.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/GrammarModifier.cs	(revision 5686)
@@ -21,48 +21,61 @@
 
 using System.Collections.Generic;
+using System.Linq;
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
   public static class GrammarModifier {
-    public static void AddDynamicSymbol(ISymbolicExpressionTreeGrammar grammar, ISymbol classRepresentative, string symbolName, int nArgs) {
-      var invokeSym = new InvokeFunction(symbolName);
+    internal static void AddInvokeSymbol(ISymbolicExpressionTreeGrammar grammar, string functionName, int nArgs, CutPoint startCutPoint, IEnumerable<CutPoint> argumentCutPoints) {
+      var invokeSym = new InvokeFunction(functionName);
       grammar.AddSymbol(invokeSym);
-      grammar.SetMinSubtreeCount(invokeSym, nArgs);
-      grammar.SetMaxSubtreeCount(invokeSym, nArgs);
-      SetSyntaxConstraints(grammar, classRepresentative, invokeSym);
-    }
+      grammar.SetSubtreeCount(invokeSym, nArgs, nArgs);
 
+      //allow invoke symbol everywhere, where the child of the startCutPoint was allowed
+      foreach (ISymbol parent in grammar.Symbols) {
+        if (grammar.IsAllowedChildSymbol(parent, startCutPoint.Child.Symbol))
+          grammar.AddAllowedChildSymbol(parent, invokeSym);
+        else {
+          for (int i = 0; i < grammar.GetMaximumSubtreeCount(parent); i++) {
+            if (grammar.IsAllowedChildSymbol(parent, startCutPoint.Child.Symbol, i))
+              grammar.AddAllowedChildSymbol(parent, invokeSym, i);
+          }
+        }
+      }
 
-    public static void AddDynamicArguments(ISymbolicExpressionTreeGrammar grammar, ISymbol classRepresentative, IEnumerable<int> argumentIndexes) {
-      foreach (int argIndex in argumentIndexes) {
-        var argSymbol = new Argument(argIndex);
-        grammar.AddSymbol(argSymbol);
-        grammar.SetMinSubtreeCount(argSymbol, 0);
-        grammar.SetMaxSubtreeCount(argSymbol, 0);
-        SetSyntaxConstraints(grammar, classRepresentative, argSymbol);
+      if (nArgs > 0) {
+        //set allowed child symbols of invoke symbol 
+        foreach (ISymbol child in grammar.Symbols) {
+          if (argumentCutPoints.All(x => grammar.IsAllowedChildSymbol(x.Parent.Symbol, child)))
+            grammar.AddAllowedChildSymbol(invokeSym, child);
+          else {
+            int i = 0;
+            foreach (CutPoint argumentCutPoint in argumentCutPoints) {
+              if (grammar.IsAllowedChildSymbol(argumentCutPoint.Parent.Symbol, child, argumentCutPoint.ChildIndex))
+                grammar.AddAllowedChildSymbol(invokeSym, child, i);
+              i++;
+            }
+          }
+        }
       }
     }
 
-    private static void SetSyntaxConstraints(ISymbolicExpressionTreeGrammar grammar, ISymbol classRepresentative, Symbol newSymbol) {
-      // allow symbol as child of the representative first to make sure that the symbol 
-      // is in the list of parents and children
-      for (int i = 0; i < grammar.GetMaxSubtreeCount(classRepresentative); i++) {
-        grammar.SetAllowedChild(classRepresentative, newSymbol, i);
-      }
-      // for all available symbols add the new symbol as allowed child iff the available symbol is an allowed child of the class representative
-      foreach (var parent in grammar.Symbols) {
-        if (grammar.IsAllowedChild(classRepresentative, parent, 0))
-          for (int arg = 0; arg < grammar.GetMaxSubtreeCount(parent); arg++) {
-            grammar.SetAllowedChild(parent, newSymbol, arg);
+    internal static void AddArgumentSymbol(ISymbolicExpressionTreeGrammar originalGrammar, ISymbolicExpressionTreeGrammar grammar, IEnumerable<int> argumentIndexes, IEnumerable<CutPoint> argumentCutPoints) {
+      foreach (var pair in argumentIndexes.Zip(argumentCutPoints, (a, b) => new { Index = a, CutPoint = b })) {
+        var argSymbol = new Argument(pair.Index);
+        grammar.AddSymbol(argSymbol);
+        grammar.SetSubtreeCount(argSymbol, 0, 0);
+
+        foreach (ISymbol parent in originalGrammar.Symbols) {
+          if (parent is StartSymbol || parent is ProgramRootSymbol) continue;
+          if (originalGrammar.IsAllowedChildSymbol(parent, pair.CutPoint.Child.Symbol))
+            grammar.AddAllowedChildSymbol(parent, argSymbol);
+          else {
+            for (int i = 0; i < originalGrammar.GetMaximumSubtreeCount(parent); i++) {
+              if (originalGrammar.IsAllowedChildSymbol(parent, pair.CutPoint.Child.Symbol, i))
+                grammar.AddAllowedChildSymbol(parent, argSymbol, i);
+            }
           }
-      }
-      // for all available symbols add the new symbol as allowed parent iff the available symbol is an allowed child of the class representative
-      foreach (var child in grammar.Symbols) {
-        if (grammar.IsAllowedChild(classRepresentative, child, 0))
-          for (int arg = 0; arg < grammar.GetMaxSubtreeCount(newSymbol); arg++) {
-            grammar.SetAllowedChild(newSymbol, child, arg);
-          }
+        }
       }
     }
-
   }
 }
Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineCreater.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineCreater.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineCreater.cs	(revision 5686)
@@ -27,6 +27,6 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Parameters;
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
@@ -61,5 +61,6 @@
     private SubroutineCreater(bool deserializing) : base(deserializing) { }
     private SubroutineCreater(SubroutineCreater original, Cloner cloner) : base(original, cloner) { }
-    public SubroutineCreater() : base() {
+    public SubroutineCreater()
+      : base() {
       Parameters.Add(new ValueLookupParameter<IntValue>(MaximumSymbolicExpressionTreeLengthParameterName, "The maximal length (number of nodes) of the symbolic expression tree."));
       Parameters.Add(new ValueLookupParameter<IntValue>(MaximumSymbolicExpressionTreeDepthParameterName, "The maximal depth of the symbolic expression tree (a tree with one node has depth = 0)."));
@@ -109,7 +110,7 @@
 
       // select a random cut point in the selected branch
-      var allCutPoints = from parent in selectedBody.IterateNodesPrefix()
-                         from subtree in parent.SubTrees
-                         select new { Parent = parent, ReplacedBranchIndex = parent.IndexOfSubTree(subtree), ReplacedBranch = subtree };
+      var allCutPoints = (from parent in selectedBody.IterateNodesPrefix()
+                          from subtree in parent.SubTrees
+                          select new CutPoint(parent, subtree)).ToList();
       if (allCutPoints.Count() == 0)
         // no cut points => abort
@@ -118,16 +119,16 @@
       var selectedCutPoint = allCutPoints.SelectRandom(random);
       // select random branches as argument cut-off points (replaced by argument terminal nodes in the function)
-      List<ISymbolicExpressionTreeNode> argumentBranches = SelectRandomArgumentBranches(selectedCutPoint.ReplacedBranch, random, ARGUMENT_CUTOFF_PROBABILITY, maxFunctionArguments);
-      ISymbolicExpressionTreeNode functionBody = selectedCutPoint.ReplacedBranch;
+      List<CutPoint> argumentCutPoints = SelectRandomArgumentBranches(selectedCutPoint.Child, random, ARGUMENT_CUTOFF_PROBABILITY, maxFunctionArguments);
+      ISymbolicExpressionTreeNode functionBody = selectedCutPoint.Child;
       // disconnect the function body from the tree
-      selectedCutPoint.Parent.RemoveSubTree(selectedCutPoint.ReplacedBranchIndex);
+      selectedCutPoint.Parent.RemoveSubTree(selectedCutPoint.ChildIndex);
       // disconnect the argument branches from the function
-      functionBody = DisconnectBranches(functionBody, argumentBranches);
+      functionBody = DisconnectBranches(functionBody, argumentCutPoints);
       // insert a function invocation symbol instead
       var invokeNode = (InvokeFunctionTreeNode)(new InvokeFunction(newFunctionName)).CreateTreeNode();
-      selectedCutPoint.Parent.InsertSubTree(selectedCutPoint.ReplacedBranchIndex, invokeNode);
+      selectedCutPoint.Parent.InsertSubTree(selectedCutPoint.ChildIndex, invokeNode);
       // add the branches selected as argument as subtrees of the function invocation node
-      foreach (var argumentBranch in argumentBranches)
-        invokeNode.AddSubTree(argumentBranch);
+      foreach (var argumentCutPoint in argumentCutPoints)
+        invokeNode.AddSubTree(argumentCutPoint.Child);
 
       // insert a new function defining branch
@@ -138,6 +139,6 @@
       // the grammar in the newly defined function is a clone of the grammar of the originating branch
       defunNode.SetGrammar((ISymbolicExpressionTreeGrammar)selectedBody.Grammar.Clone());
-      // remove all argument symbols from grammar
-      var oldArgumentSymbols = defunNode.Grammar.Symbols.OfType<Argument>().ToList();
+      // remove all argument symbols from grammar except that one contained in cutpoints
+      var oldArgumentSymbols = selectedBody.Grammar.Symbols.OfType<Argument>().ToList();
       foreach (var oldArgSymb in oldArgumentSymbols)
         defunNode.Grammar.RemoveSymbol(oldArgSymb);
@@ -146,15 +147,9 @@
                                 select node.Symbol.ArgumentIndex).Distinct();
       // add argument symbols to grammar of function defining branch
-      GrammarModifier.AddDynamicArguments(defunNode.Grammar, defunNode.Symbol, newArgumentIndexes);
+      GrammarModifier.AddArgumentSymbol(selectedBody.Grammar, defunNode.Grammar, newArgumentIndexes, argumentCutPoints);
       defunNode.NumberOfArguments = newArgumentIndexes.Count();
-      if (defunNode.NumberOfArguments != argumentBranches.Count) throw new InvalidOperationException();
+      if (defunNode.NumberOfArguments != argumentCutPoints.Count) throw new InvalidOperationException();
       // add invoke symbol for newly defined function to the original branch 
-      var allowedParents = from symb in selectedBody.Grammar.Symbols
-                           where !(symb is ProgramRootSymbol)
-                           select symb;
-      var allowedChildren = from symb in selectedBody.Grammar.Symbols
-                            where selectedBody.Grammar.IsAllowedChild(selectedBody.Symbol, symb, 0)
-                            select symb;
-      GrammarModifier.AddDynamicSymbol(selectedBody.Grammar, selectedBody.Symbol, defunNode.FunctionName, defunNode.NumberOfArguments);
+      GrammarModifier.AddInvokeSymbol(selectedBody.Grammar, defunNode.FunctionName, defunNode.NumberOfArguments, selectedCutPoint, argumentCutPoints);
 
       // when the new function body was taken from another function definition
@@ -168,11 +163,5 @@
           // when the original branch can be invoked from the subtree then also allow invocation of the function
           if (originalBranchInvokeSymbol != null) {
-            allowedParents = from symb in subtree.Grammar.Symbols
-                             where !(symb is ProgramRootSymbol)
-                             select symb;
-            allowedChildren = from symb in subtree.Grammar.Symbols
-                              where subtree.Grammar.IsAllowedChild(subtree.Symbol, symb, 0)
-                              select symb;
-            GrammarModifier.AddDynamicSymbol(subtree.Grammar, subtree.Symbol, defunNode.FunctionName, defunNode.NumberOfArguments);
+            GrammarModifier.AddInvokeSymbol(subtree.Grammar, defunNode.FunctionName, defunNode.NumberOfArguments, selectedCutPoint, argumentCutPoints);
           }
         }
@@ -181,7 +170,7 @@
     }
 
-    private static ISymbolicExpressionTreeNode DisconnectBranches(ISymbolicExpressionTreeNode node, List<ISymbolicExpressionTreeNode> argumentBranches) {
-      if (argumentBranches.Contains(node)) {
-        var argumentIndex = argumentBranches.IndexOf(node);
+    private static ISymbolicExpressionTreeNode DisconnectBranches(ISymbolicExpressionTreeNode node, List<CutPoint> argumentCutPoints) {
+      int argumentIndex = argumentCutPoints.FindIndex(x => x.Child == node);
+      if (argumentIndex != -1) {
         var argSymbol = new Argument(argumentIndex);
         return argSymbol.CreateTreeNode();
@@ -192,10 +181,10 @@
       // recursively apply function for subtrees or append a argument terminal node
       foreach (var subtree in subtrees) {
-        node.AddSubTree(DisconnectBranches(subtree, argumentBranches));
+        node.AddSubTree(DisconnectBranches(subtree, argumentCutPoints));
       }
       return node;
     }
 
-    private static List<ISymbolicExpressionTreeNode> SelectRandomArgumentBranches(ISymbolicExpressionTreeNode selectedRoot,
+    private static List<CutPoint> SelectRandomArgumentBranches(ISymbolicExpressionTreeNode selectedRoot,
       IRandom random,
       double cutProbability,
@@ -203,7 +192,7 @@
       // breadth first determination of argument cut-off points
       // we must make sure that we cut off all original argument nodes and that the number of new argument is smaller than the limit
-      List<ISymbolicExpressionTreeNode> argumentBranches = new List<ISymbolicExpressionTreeNode>();
+      List<CutPoint> argumentBranches = new List<CutPoint>();
       if (selectedRoot is ArgumentTreeNode) {
-        argumentBranches.Add(selectedRoot);
+        argumentBranches.Add(new CutPoint(selectedRoot.Parent, selectedRoot));
         return argumentBranches;
       } else {
@@ -213,12 +202,15 @@
                                            select nArgumentsInTree).ToList();
         // determine the minimal number of new argument nodes for each sub-tree
+        //if we exceed the maxArguments return the same cutpoint as the start cutpoint to create a ADF that returns only its argument
         var minNewArgumentsForSubtrees = numberOfArgumentsInSubtrees.Select(x => x > 0 ? 1 : 0).ToList();
         if (minNewArgumentsForSubtrees.Sum() > maxArguments) {
-          argumentBranches.Add(selectedRoot);
+          argumentBranches.Add(new CutPoint(selectedRoot.Parent, selectedRoot));
           return argumentBranches;
         }
         // cut-off in the sub-trees in random order
         var randomIndexes = (from index in Enumerable.Range(0, selectedRoot.SubTrees.Count())
-                             select new { Index = index, OrderValue = random.NextDouble() }).OrderBy(x => x.OrderValue).Select(x => x.Index);
+                             select new { Index = index, OrderValue = random.NextDouble() })
+                             .OrderBy(x => x.OrderValue)
+                             .Select(x => x.Index);
         foreach (var subtreeIndex in randomIndexes) {
           var subtree = selectedRoot.GetSubTree(subtreeIndex);
@@ -237,5 +229,5 @@
           } else {
             // cut-off at current sub-tree
-            argumentBranches.Add(subtree);
+            argumentBranches.Add(new CutPoint(subtree.Parent, subtree));
           }
         }
Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDeleter.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDeleter.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDeleter.cs	(revision 5686)
@@ -26,5 +26,4 @@
 using HeuristicLab.Data;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using System.Collections.Generic;
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
@@ -87,28 +86,28 @@
                                 from subtree in node.SubTrees.OfType<InvokeFunctionTreeNode>()
                                 where subtree.Symbol.FunctionName == selectedDefunBranch.FunctionName
-                                select new { Parent = node, ReplacedChildIndex = node.IndexOfSubTree(subtree), ReplacedChild = subtree }).FirstOrDefault();
+                                select new CutPoint(node, subtree)).FirstOrDefault();
       while (invocationCutPoint != null) {
         // deletion by random regeneration
         ISymbolicExpressionTreeNode replacementTree = null;
-        var allowedSymbolsList = invocationCutPoint.Parent.Grammar.GetAllowedSymbols(invocationCutPoint.Parent.Symbol, invocationCutPoint.ReplacedChildIndex).ToList();
+        var allowedSymbolsList = invocationCutPoint.Parent.Grammar.GetAllowedChildSymbols(invocationCutPoint.Parent.Symbol, invocationCutPoint.ChildIndex).ToList();
         var weights = allowedSymbolsList.Select(s => s.InitialFrequency);
         var selectedSymbol = allowedSymbolsList.SelectRandom(weights, random);
 
-        int minPossibleLength = invocationCutPoint.Parent.Grammar.GetMinExpressionLength(selectedSymbol);
-        int maxLength = Math.Max(minPossibleLength, invocationCutPoint.ReplacedChild.GetLength());
-        int minPossibleDepth = invocationCutPoint.Parent.Grammar.GetMinExpressionDepth(selectedSymbol);
-        int maxDepth = Math.Max(minPossibleDepth, invocationCutPoint.ReplacedChild.GetDepth());
+        int minPossibleLength = invocationCutPoint.Parent.Grammar.GetMinimumExpressionLength(selectedSymbol);
+        int maxLength = Math.Max(minPossibleLength, invocationCutPoint.Child.GetLength());
+        int minPossibleDepth = invocationCutPoint.Parent.Grammar.GetMinimumExpressionDepth(selectedSymbol);
+        int maxDepth = Math.Max(minPossibleDepth, invocationCutPoint.Child.GetDepth());
         replacementTree = selectedSymbol.CreateTreeNode();
         if (replacementTree.HasLocalParameters)
           replacementTree.ResetLocalParameters(random);
-        invocationCutPoint.Parent.RemoveSubTree(invocationCutPoint.ReplacedChildIndex);
-        invocationCutPoint.Parent.InsertSubTree(invocationCutPoint.ReplacedChildIndex, replacementTree);
+        invocationCutPoint.Parent.RemoveSubTree(invocationCutPoint.ChildIndex);
+        invocationCutPoint.Parent.InsertSubTree(invocationCutPoint.ChildIndex, replacementTree);
 
-        ProbabilisticTreeCreator.PTC2(random, replacementTree, maxLength, maxDepth, 0, 0);
+        ProbabilisticTreeCreator.PTC2(random, replacementTree, maxLength, maxDepth);
 
         invocationCutPoint = (from node in symbolicExpressionTree.IterateNodesPrefix()
                               from subtree in node.SubTrees.OfType<InvokeFunctionTreeNode>()
                               where subtree.Symbol.FunctionName == selectedDefunBranch.FunctionName
-                              select new { Parent = node, ReplacedChildIndex = node.IndexOfSubTree(subtree), ReplacedChild = subtree }).FirstOrDefault();
+                              select new CutPoint(node, subtree)).FirstOrDefault();
       }
     }
